import { 
  select, 
  csv, 
  scaleLinear, 
  max, 
  scaleBand, 
  axisLeft,
  axisBottom
} from 'd3';
import {transitionWidth} from '/myscript';

const svg = select('svg');


const width = +svg.attr('width');
const height = +svg.attr('height');

const render = data => {
  const xValue = d => d.budget;
  const yValue = d => d.movietitle;
  const margin = {top: 20, right: 50, bottom: 20, left: 100};
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;
  
  const xScale = scaleLinear()
  	.domain([0, max(data, xValue)])
  	.range([0, innerWidth]);
  
  const yScale = scaleBand()
  	.domain(data.map(yValue))
  	.range([0, innerHeight])
  	.padding(0.14);
  
  
  
  
  const colorScale= scaleLinear()
      .domain([0, max(data, xValue)])
      .range(["IndianRed","red"]);
  
  const g = svg.append('g')
  	.attr('transform', `translate(${margin.left}, ${margin.top})`);
  

    
  g.append('g').call(axisLeft(yScale));
  g.append('g').call(axisBottom(xScale))
  	.attr('transform', `translate(0, ${innerHeight})`);


  var bars = g.selectAll('rect').data(data)
  	.enter().append('rect')
  		.attr('y', d => yScale(yValue(d)))
  		.attr('width', d => xScale(xValue(d)))
  		.attr('height', yScale.bandwidth())
 			.attr('fill', d => colorScale(xValue(d)))
  		.attr('title', d => yValue(d))
   
			.on("mouseover", function() {
d3.select("#hallo")._groups[0][0].innerHTML=((d3.select(this)._groups[0][0].__data__.movietitle) + ": " +d3.select(this)._groups[0][0].__data__.budget)
 + " : " +(d3.select(this)._groups[0][0].__data__.imdbscore)});
 

  
 let Test = () => {
  if (bars.attr('width')>0)
    {
				transitionWidth(bars, 0, 1000);
      	circle.attr('fill', 'red');
    }
  else
    {
    		transitionWidth(bars, d => xScale(xValue(d)), 1000)
      	circle.attr('fill', 'blue');
    }
  }
  
  var circle = g.append('circle')
    .attr('r', 10)
  	.attr('fill', 'green')
    .attr('transform', `translate(${innerWidth/2}, ${innerHeight/2})`)
  	.on("click", Test);

  g.append('p')
  .text("hallo")
  .attr('transform', `translate(${innerWidth/2}, ${innerHeight/2})`);

  g.append('text')
    	.attr('class', 'title')
    	.attr('y', -5)
  		.text('movietitle V/S budget with comparing imdbscore ');
       
  
      };

csv('data.csv').then(data => {
  data.forEach(d => {
  	d.budget = +d.budget;
  }); 

  render(data);  

});